//#if MB191
package mobilebasic;
//#endif

import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;
import javax.microedition.media.protocol.DataSource;
import javax.microedition.media.Manager;
import javax.microedition.media.MediaException;
import javax.microedition.media.Player;
import javax.microedition.media.PlayerListener;
import javax.microedition.media.control.VolumeControl;
import java.util.Enumeration;

public class AudioPlayback implements PlayerListener {

    private Hashtable sounds = new Hashtable();

    public void playerUpdate(Player p, String s, Object sender){
        System.out.println(s);
    }
    private int val(String var) {
        try {
            return Integer.parseInt(var);
        } catch (NumberFormatException e) {
            return -1;
        }
    }

    public void clear() {
        Enumeration keys = sounds.keys();
        while (keys.hasMoreElements()) {
            String key = (String)keys.nextElement();
            delete(key);
    }
        sounds = new Hashtable();
    }
    public void create(String path) {
        path = path.trim();
        Player player = null;
        String type = null;
        try {
            if (path.startsWith("http") || path.startsWith("socket:")) {
                player = Manager.createPlayer(path);
            } else {
                if (!(type = path.toLowerCase()).endsWith(".mid") && !path.endsWith(".kar") && !path.endsWith(".midi")) {
                    if (path.endsWith(".imy")) {
                        type = "audio/imelody";
                    } else if (path.endsWith(".bas")) {
                        type = "audio/bas";
                    } else if (!path.endsWith(".wav") && !path.endsWith(".wave")) {
                        if (path.endsWith(".amr")) {
                            type = "audio/amr";
                        } else if (path.endsWith(".mp3")) {
                            type = "audio/mpeg";
                        } else if (path.endsWith(".m4a")) {
                            type = "audio/m4a";
                        } else if (path.endsWith(".aac")) {
                            type = "audio/aac";
                        } else if (path.endsWith(".wma")) {
                            type = "audio/x-ms-wma";
                        }
                    } else {
                        type = "audio/x-wav";
                    }
                } else {
                    type = "audio/midi";
                }

                InputStream is;
                if (path.startsWith("file:")) {
                    is = Connector.openInputStream(path);
                } else {
                    is = getClass().getResourceAsStream("/" + path);
                }
                player = Manager.createPlayer(is, type);
            }
            player.addPlayerListener(this);
            player.realize();
            player.prefetch();
            ((VolumeControl)player.getControl("VolumeControl")).setLevel(100);
            sounds.put(path, player);
        } catch (MediaException me) {
        } catch (IOException ioe) {
        }
    }

    public void play(String var) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return;
        }
        
        try {
           ((Player) sounds.get(var)).start();;
        } catch (MediaException e) {
        }
    }

    public int duration(String var) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return -1;
        }
        return (int)((Player) sounds.get(var)).getDuration()/1000;
    }
    
    public int mediatime(String var) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return -1;
        }
        return (int)((Player) sounds.get(var)).getMediaTime()/1000;
    }
    
    public void setMediatime(String var, int mt) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return;
        }
        try {
            ((Player) sounds.get(var)).setMediaTime((long)(mt*1000));
        } catch (MediaException me) {
            
        }
    }
    
    public void setLoopCount(String var, int cnt) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return;
        }
        ((Player) sounds.get(var)).setLoopCount(cnt);
    }
    
    public void setLevelVolume(String var, int level) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return;
        }
        
        if (level < 0) {
            level = 0;
        }
        if (level > 100) {
            level = 100;
        }
        ((VolumeControl) ((Player) sounds.get(var)).getControl("VolumeControl"))
                .setLevel(level);
    }

    public void stop(String var) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return;
        }
        
        try {
            ((Player) sounds.get(var)).stop();
        } catch (MediaException me) {
        }
    }

    public void delete(String var) {
        var = var.trim();
        if (!sounds.containsKey(var)) {
            return;
        }
        
        stop(var);
        ((Player) sounds.get(var)).deallocate();
        sounds.remove(var);
        System.gc();
    }

    public static void playTone(int note, int duration, int vol) {
        try {
            Manager.playTone(60 + note, duration, vol);
        } catch (MediaException e) {
        }
    }
}
